// Warehouse.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

import swarm.collections.ListImpl;

/**
 * the Warehouset class is used to operate with inventories.
 *
 * @author Marco Remondino and Pietro Terna
 */
public class Warehouse extends SwarmObjectImpl implements PTHistogramPlottable{

    /** the number of this wharehouse */
    public int warehouseNumber; 
    /** the counter which of inventory quantity
     * (in this versione the inventory smallest piece of inventory is 1) */
    public int inventoryCounter;
	
  
    /** 
     * The constructor for Warehouse 
     */
    public Warehouse (Zone aZone, int n) {

	// call the constructor for the warehouse parent class
	super(aZone);

	// the warehouse id number
	warehouseNumber=n;
	inventoryCounter = 0;
	// announce the warehouse presence to the console
	if(StartVEFrame.verbose)
	    System.out.println("Warehouse number " + warehouseNumber + 
			       " has been created.");    }
	 
    /** the inventory quantity in the warehouse */
	public int getInventoryQuantity() {
	    return inventoryCounter;
	}
	
    /** the number of this warehouse */  
	public int getWarehouseNumber() {
	return warehouseNumber;
	}	
	
    /** increasing inventories */
    public void increaseInventoryCounterValue() {
	inventoryCounter++;
	return;
    }

    /** decreasing inventories and returning the result*/
    public int decreaseInventoryCounterValue()
    {
	if(getInventoryQuantity() > 0)
	    {		
		inventoryCounter--;
		return 1;
	    }
	return 0;
    }	

    /** checking if the warehouse is empty */
    public boolean empty()
    {
	if(getInventoryQuantity() > 0) return false;
	else return true;
    }	

    /* PTHistogramPlottable interface method: getLabel() */
    public String getLabel(){
	return "";
    }

    /* PTHistogramPlottable interface method: getValueToPlot() */
    public double getValueToPlot(){
	return (double) getInventoryQuantity();
    }

}


